package jp.co.sds_corp.hibiya.monitor.checker;

import java.util.Arrays;
import java.util.ResourceBundle;

import javax.swing.BoxLayout;
import javax.swing.JPanel;

import jp.co.sds_corp.hibiya.monitor.Column;
import jp.co.sds_corp.hibiya.server.CPUChecker;
import jp.co.sds_corp.hibiya.server.IChecker;
import jp.co.sds_corp.util.window.ValuePanel;

/**
* {@link CPUChecker}の設定を行うパネルです。
*/
public class CPUPanel extends AbstractPanel
{
	private static final long serialVersionUID = 1L;
	ValuePanel	VAL_MAX = new ValuePanel( ValuePanel.ReturnType.INT, "Max Load:" );
	ResourceBundle	res;

	public CPUPanel() {
		res = ResourceBundle.getBundle( "resource.monitor" );
		testChecker = new CPUChecker();
		createSetupPanel();
	}

	void createSetupPanel() {
		JPanel pnl = new JPanel();
		pnl.setLayout( new BoxLayout( pnl, BoxLayout.Y_AXIS ));
		pnl.add( VAL_NAME );
		pnl.add( VAL_MAX );
		pnl.add( VAL_INT );
		pnl.add( CHK_HIST );
		add( pnl );
		add( BTN_TEST );
	}

	public void setChecker( IChecker var ) {
		super.setChecker( var );
		CPUChecker mon = (CPUChecker )var;
		VAL_MAX.setValue( String.valueOf( mon.getMaxLoad() ));
	}
	public void checkSetup() throws Exception {
		super.checkSetup();
		Integer nvar = (Integer )VAL_MAX.getValue();
		if ( nvar == null || nvar.intValue() <= 0 ) {
			String msg = res.getString( "checker.cpu.err1.message" );
			throw( new Exception( msg ));
		}
	}
	public void setupChecker( IChecker var ) throws Exception {
		CPUChecker mon = (CPUChecker )var;
		super.setupChecker( var );
		mon.setMaxLoad( ((Integer )VAL_MAX.getValue()).intValue() );
	}

	public void setEnabled( boolean bEn ) {
		super.setEnabled( bEn );
		VAL_MAX.setEnabled( bEn );
	}

	public Class<? extends IChecker> getCheckerClass() {
		return CPUChecker.class;
	}

	static Column[] col = {
		new Column( "Status" ), new Column( "Name" ),
		new Column( "MaxLoad" ),
		new Column( "Interval" ), new Column( "Exception" )
	};
	static java.util.List<Column> colList = Arrays.asList( col );

	public java.util.List<Column> getAllColumn() {
		return colList;
	}

}

