package jp.co.sds_corp.hibiya.monitor.checker;

import java.util.Arrays;

import javax.swing.BoxLayout;
import javax.swing.JPanel;

import jp.co.sds_corp.hibiya.monitor.Column;
import jp.co.sds_corp.hibiya.server.DbChecker;
import jp.co.sds_corp.hibiya.server.IChecker;
import jp.co.sds_corp.util.window.ValuePanel;

/**
* {@link DbChecker}を設定するパネルです。
*/
public class DbPanel extends AbstractPanel
{
	private static final long serialVersionUID = 1L;
	ValuePanel	VAL_JAR = new ValuePanel( ValuePanel.ReturnType.STRING, "Jar File:" );
	ValuePanel	VAL_DRV = new ValuePanel( ValuePanel.ReturnType.STRING, "Driver:" );
	ValuePanel	VAL_URL = new ValuePanel( ValuePanel.ReturnType.STRING, "URL:" );
	ValuePanel	VAL_USR = new ValuePanel( ValuePanel.ReturnType.STRING, "User:" );
	ValuePanel	VAL_PWD = new ValuePanel( ValuePanel.ReturnType.STRING, ValuePanel.Type.PASSWORD, "Password:" );
	ValuePanel	VAL_TBL = new ValuePanel( ValuePanel.ReturnType.STRING, "Table:" );
	ValuePanel	VAL_SQL = new ValuePanel( ValuePanel.ReturnType.STRING, "SQL:" );

	public DbPanel() {
		testChecker = new DbChecker();
		createSetupPanel();
	}

	void createSetupPanel() {
		JPanel pnl = new JPanel();
		pnl.setLayout( new BoxLayout( pnl, BoxLayout.Y_AXIS ));
		pnl.add( VAL_NAME );
		pnl.add( VAL_JAR );
		pnl.add( VAL_DRV );
		pnl.add( VAL_URL );
		pnl.add( VAL_USR );
		pnl.add( VAL_PWD );
		pnl.add( VAL_TBL );
		pnl.add( VAL_SQL );
		pnl.add( VAL_INT );
		pnl.add( CHK_HIST );
		add( pnl );
		add( BTN_TEST );
	}

	public void setChecker( IChecker var ) {
		super.setChecker( var );
		DbChecker mon = (DbChecker )var;
		VAL_JAR.setValue( mon.getJar() );
		VAL_DRV.setValue( mon.getDriver() );
		VAL_URL.setValue( mon.getURL() );
		VAL_USR.setValue( mon.getUser() );
		VAL_PWD.setValue( mon.getPassword() );
		VAL_TBL.setValue( mon.getTable() );
		VAL_SQL.setValue( mon.getSql() );
	}

	public void checkSetup() throws Exception {
		super.checkSetup();
		String var;
		var = (String )VAL_DRV.getValue();
		if ( var == null || var.length() == 0 ) {
			String msg = res.getString( "checker.db.err1.message" );
			throw( new Exception( msg ));
		}
		var = (String )VAL_URL.getValue();
		if ( var == null || var.length() == 0 ) {
			String msg = res.getString( "checker.db.err2.message" );
			throw( new Exception( msg ));
		}
		var = (String )VAL_TBL.getValue();
		if ( var == null || var.length() == 0 ) {
			var = (String )VAL_SQL.getValue();
			if ( var == null || var.length() == 0 ) {
				String msg = res.getString( "checker.db.err3.message" );
				throw( new Exception( msg ));
			}
		}
	}
	public void setupChecker( IChecker chk ) throws Exception {
		super.setupChecker( chk );
		DbChecker mon = (DbChecker )chk;
		mon.setJar( (String )VAL_JAR.getValue() );
		mon.setDriver( (String )VAL_DRV.getValue() );
		mon.setURL( (String )VAL_URL.getValue() );
		mon.setUser( (String )VAL_USR.getValue() );
		mon.setPassword( (String )VAL_PWD.getValue() );
		mon.setTable( (String )VAL_TBL.getValue() );
		mon.setSql( (String )VAL_SQL.getValue() );
	}

	public void setEnabled( boolean bEn ) {
		super.setEnabled( bEn );
		VAL_JAR.setEnabled( bEn );
		VAL_DRV.setEnabled( bEn );
		VAL_URL.setEnabled( bEn );
		VAL_USR.setEnabled( bEn );
		VAL_PWD.setEnabled( bEn );
		VAL_TBL.setEnabled( bEn );
		VAL_SQL.setEnabled( bEn );
	}

	public Class<? extends IChecker> getCheckerClass() {
		return DbChecker.class;
	}

	static Column[] col = {
		new Column( "Status" ), new Column( "Name" ),
		new Column( "URL" ), new Column( "Driver" ),
		new Column( "User" ), new Column( "Password", true ),
		new Column( "Table" ), new Column( "Sql" ),
		new Column( "Interval" ), new Column( "Exception" )
	};
	static java.util.List<Column> colList = Arrays.asList( col );

	public java.util.List<Column> getAllColumn() {
		return colList;
	}

}

