package jp.co.sds_corp.hibiya.monitor.checker;

import java.util.Arrays;

import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JCheckBox;
import javax.swing.JPanel;

import jp.co.sds_corp.hibiya.monitor.Column;
import jp.co.sds_corp.hibiya.server.IChecker;
import jp.co.sds_corp.hibiya.server.MemoryChecker;
import jp.co.sds_corp.util.window.ValuePanel;

/**
* {@link MemoryChecker}の設定を行うパネルです。
*/
public class MemoryPanel extends AbstractPanel
{
	private static final long serialVersionUID = 1L;
	ValuePanel	VAL_MIN = new ValuePanel( ValuePanel.ReturnType.INT, "Minimum:" );
	JCheckBox	CHK_CACHE = new JCheckBox( "IncludeCache:" );

	public MemoryPanel() {
		testChecker = new MemoryChecker();
		createSetupPanel();
	}

	void createSetupPanel() {
		JPanel pnl = new JPanel();
		pnl.setLayout( new BoxLayout( pnl, BoxLayout.Y_AXIS ));
		pnl.add( VAL_NAME );
		pnl.add( VAL_MIN );
		Box box1 = new Box( BoxLayout.X_AXIS );
		box1.add( CHK_CACHE );
		box1.add( Box.createHorizontalGlue());
		pnl.add( box1 );
		pnl.add( VAL_INT );
		pnl.add( CHK_HIST );
		add( pnl );
		add( BTN_TEST );
	}

	public void setChecker( IChecker var ) {
		super.setChecker( var );
		MemoryChecker mon = (MemoryChecker )var;
		VAL_MIN.setValue( String.valueOf( mon.getMinimum() ));
		if ( mon.getIncludeCache()) {
			CHK_CACHE.setSelected( true );
		} else {
			CHK_CACHE.setSelected( false );
		}
	}
	public void checkSetup() throws Exception {
		super.checkSetup();
		Integer nvar = (Integer )VAL_MIN.getValue();
		if ( nvar == null || nvar.intValue() <= 0 ) {
			String msg = res.getString( "checker.memory.err1.message" );
			throw( new Exception( msg ));
		}
	}
	public void setupChecker( IChecker chk ) throws Exception {
		super.setupChecker( chk );
		MemoryChecker mon = (MemoryChecker )chk;
		mon.setMinimum( ((Integer )VAL_MIN.getValue()).intValue() );
		mon.setIncludeCache( CHK_CACHE.isSelected());
	}

	public void setEnabled( boolean bEn ) {
		super.setEnabled( bEn );
		VAL_MIN.setEnabled( bEn );
		CHK_CACHE.setEnabled( bEn );
	}

	public Class<? extends IChecker> getCheckerClass() {
    	return MemoryChecker.class;
	}

	static Column[] col = {
		new Column( "Status" ), new Column( "Name" ),
		new Column( "Minimum" ), new Column( "IncludeCache" ),
		new Column( "Interval" ), new Column( "Exception" )
	};
	static java.util.List<Column> colList = Arrays.asList( col );

	public java.util.List<Column> getAllColumn() {
		return colList;
	}

}

